<template>
  <div class="gris">
    <v-data-table
      :headers="headers"
      :items="items"
      :page.sync="page"
      :items-per-page="itemsPerPage"
      hide-default-footer
      @page-count="pageCount = $event"
      class="tabla"
      :id="getId"
    >
      <template v-slot:item="row">
        <tr>
          <td align="center">
            {{ row.item.fecha }}
          </td>

          <td align="center">
                
                <router-link class="liga" style="color: #2d2926" 
                :to="{ name: 'certificacion_calidad_certificacion_detalle', 
                params:{ visita:serviceCommons.objectToBase64(row.item)}}">
                  {{ row.item.detalle }}</router-link>

          </td>

          <td align="center">
             <div style="display: inline-block;">
                <span
                  class="circulo"
                  v-bind:style="{
                    background: row.item.rango_color,
                  }"
                ></span>
                <strong style="vertical-align: top">
                  {{ row.item.calificacion }}
                </strong>
              </div>
          </td>

          <td align="center">
                <router-link class="liga" style="color: #2d2926" 
                :to="{ name: 'certificacion_calidad_certificador_detalle', 
                  params:{ 
                    puntoVenta:serviceCommons.objectToBase64(row.item),
                    filtros:serviceCommons.objectToBase64(filtrosFechas)
                    
                  }
                }">
                  {{ row.item.nombre_usuario }}</router-link>
          </td>

          <td align="center">
            {{ row.item.hora_entrada }}
          </td>

          <td align="center">
            {{ row.item.hora_salida }}
          </td>
        </tr>
      </template>
    </v-data-table>
    <div class="text-center pt-2">
      <v-pagination
        v-model="page"
        :length="pageCount"
        class="paginador"
      ></v-pagination>
    </div>
  </div>
</template>

<style scoped>
.circulo {
  width: 20px;
  height: 20px;
  border-radius: 50%;
  display: inline-block;
}
</style>

<script>
import store from "@/store";
import axios from "axios";
import router from "@/router";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "TablaPuntoVentaCertPrevias",
  props: {
    visita: Object,
  },
  data() {
    return {
      serviceCommons,
      items: [],
      page: 1,
      pageCount: 1,
      itemsPerPage: 10,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
      },
      filtros:{

      },
      filtrosFechas:{

      },
      headers: [
        {
          text: "Fecha",
          value: "fecha",
          align: "center",
        },
        {
          text: "Certificación",
          value: "detalle",
          align: "center",
        },
        {
          text: "Calificación",
          value: "calificacion",
          align: "center",
        },
        {
          text: "Certificador",
          value: "nombre_usuario",
          align: "center",
        },
        {
          text: "Hora Entrada",
          value: "hora_entrada",
          align: "center",
        },
        {
          text: "Hora Salida",
          value: "hora_salida",
          align: "center",
        },
      ],
    };
  },
  created() {
    
  },
  mounted() {},
  computed: {
    getId() {
      if (this.visita.id_ceco_base) {
        this.getPeridoInfo();
        return 1;
      } else {
        return 1;
      }
    },
  },
  methods: {
   getPeridoInfo() {
      const self = this;
      axios
        .get("franquicia/periodo/secure/get/actual")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                //Se comenta el bimestre para traer solo fechas del trimestre. 
                //PENDIENTE Parametrizar el periodo.
                data.bimestre = null;
                delete data.festivo
                self.getFechasPeriodo(data);
              }else{
                 
                 self.filtros.fechaInicio = "01/01/2021";
                 self.filtros.fechaFin = "31/03/2021";
                 self.filtros.id_ceco_base = self.visita.id_ceco_base;
                 self.filtrosFechas.fechaInicio = "01/01/2021";
                 self.filtrosFechas.fechaFin = "31/03/2021";
                 self.getCertificacionesPrevias();
              }
              
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getFechasPeriodo(periodo){
      const self = this;
      axios
        .post("franquicia/periodo/secure/get/fechas",periodo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                let anio = data.fecha_fin.split("/")[2];
                 self.filtros.fechaInicio = "01/01/"+anio;
                 self.filtros.fechaFin = data.fecha_fin;
                 self.filtros.id_ceco_base = self.visita.id_ceco_base;
                 self.filtrosFechas.fechaInicio = data.fecha_inicio;
                 self.filtrosFechas.fechaFin = data.fecha_fin;
                 self.getCertificacionesPrevias();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getCertificacionesPrevias() {
      const self = this;
      let url =
        "/franquicia/dashboard/g014/secure/grafico/get/certificaciones/previas/?" +
        "idCecoBase=" +
        this.filtros.id_ceco_base +
        "&fechaInicial=" +
        this.filtros.fechaInicio +
        "&fechaFinal=" +
        this.filtros.fechaFin;
      axios
        .get(url)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                data.forEach((element) => {
                  element.detalle = "Detalle de la Certificación";
                  if (element.hora_entrada) {
                    element.hora_entrada = element.hora_entrada + " hrs";
                  }
                  if (element.hora_salida) {
                    element.hora_salida = element.hora_salida + " hrs";
                  }
                  if (element.fecha) {
                    let fecha = element.fecha.split(" ")[0];
                    let dia = fecha.split("-")[2];
                    let mes = fecha.split("-")[1];
                    let anio = fecha.split("-")[0];

                    element.fecha = dia + "/" + mes + "/" + anio;
                    element.fecha_visita = element.fecha;
                  }
                });

                self.items = data;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
};
</script>
